import json
import urllib.parse
import boto3
import sys
from Psi_I_process import *   


#print('Loading function')

s3 = boto3.client('s3')
dynamodb = boto3.resource('dynamodb')


def lambda_handler(event, context):

    #______Get the object from the event and check the bucket
    bucket = event['Records'][0]['s3']['bucket']['name']
    key = urllib.parse.unquote_plus(event['Records'][0]['s3']['object']['key'], encoding='utf-8')
    #if bucket[0:14] != "solearnoidvalve":#
    #    sys.exit("trigger from another bucket")  # or exit(0)?
    #else:
    #    sys,exit("correct!")
    #
    try:
        response = s3.get_object(Bucket=bucket, Key=key)
        content = response["Body"].read().decode("utf-8")
        content = json.loads(content)
    except Exception as e:
        print(e)
        print('Error getting object {} from bucket {}. Make sure they exist and your bucket is in the same region as this function.'.format(key, bucket))
        raise e
    
    
    #______Check test id.. waiting for a switchOFF (falling) curve to retreive the complementary rising part
    
    if content["testID"]== 0: # falling_branch
        falling = content
        key = str(int(key)-99) # see bucket primary key composition 
        
        try:
            response = s3.get_object(Bucket=bucket, Key=key)    # get rising branch
            rising = response["Body"].read().decode("utf-8")
            rising = json.loads(rising)
        except Exception as e:
            print(e)
            print('Error getting object {} from bucket {}. Make sure they exist and your bucket is in the same region as this function.'.format(key, bucket))
            raise e

   #______Create the new item 
   
        newItem = Dynamo_DB_Psi_I(rising, falling)
        Table_name = "SolearnoidValve" + str(falling["valveID"])
        print(Table_name)
        print(newItem)
        
        
   #______Put the new item in the table in Dynamo DB.
    
        try:
            #pass
            Table = dynamodb.Table(Table_name)
            Table.put_item(Item = newItem)
            
        except Exception as e:
            print(e)
            raise e
    

        
        

    